TanStack

Vue Example: UseThrottledValue

<script setup lang="ts">
import { TanStackDevtools } from '@tanstack/vue-devtools'
import { pacerDevtoolsPlugin } from '@tanstack/vue-pacer-devtools'
import { ref } from 'vue'
import { useThrottledValue } from '@tanstack/vue-pacer/throttler'

const dev = import.meta.env.DEV
const plugins = [pacerDevtoolsPlugin()]

const instantCount = ref(0)

function increment() {
  instantCount.value = instantCount.value + 1
}

const [throttledCount] = useThrottledValue(
  () => instantCount.value,
  () => ({
    wait: 1000,
    // enabled: () => instantCount > 2, // optional, defaults to true
  }),
)

const instantSearch = ref('')

const [throttledSearch] = useThrottledValue(
  () => instantSearch.value,
  () => ({
    wait: 1000,
    // enabled: instantSearch.length > 2, // optional, defaults to true
  }),
)

function handleSearchChange(e: Event) {
  instantSearch.value = (e.target as HTMLInputElement).value
}

const submittedCount = ref(1)

const currentValue = ref(50)

const [throttledValue, throttler] = useThrottledValue(
  () => currentValue.value,
  () => ({
    wait: 250,
  }),
)

function handleRangeChange(e: Event) {
  const newValue = parseInt((e.target as HTMLInputElement).value, 10)
  currentValue.value = newValue
  submittedCount.value = submittedCount.value + 1
}
</script>

<template>
  <div>
    <div>
      <h1>TanStack Pacer useThrottledValue Example 1</h1>
      <table>
        <tbody>
          <tr>
            <td>Instant Count:</td>
            <td>{{ instantCount }}</td>
          </tr>
          <tr>
            <td>Throttled Count:</td>
            <td>{{ throttledCount }}</td>
          </tr>
        </tbody>
      </table>
      <div><button @click="increment">Increment</button></div>
    </div>
    <hr />
    <div>
      <h1>TanStack Pacer useThrottledValue Example 2</h1>
      <div>
        <input
          type="search"
          :value="instantSearch"
          @input="handleSearchChange"
          placeholder="Type to search..."
          :style="{ width: '100%' }"
        />
      </div>
      <table>
        <tbody>
          <tr>
            <td>Instant Search:</td>
            <td>{{ instantSearch }}</td>
          </tr>
          <tr>
            <td>Throttled Search:</td>
            <td>{{ throttledSearch }}</td>
          </tr>
        </tbody>
      </table>
    </div>
    <hr />
    <div>
      <h1>TanStack Pacer useThrottledValue Example 3</h1>
      <div :style="{ marginBottom: '20px' }">
        <label
          >Current Range:<input
            type="range"
            min="0"
            max="100"
            :value="currentValue"
            @input="handleRangeChange"
            :style="{ width: '100%' }"
          /><span>{{ currentValue }}</span></label
        >
      </div>
      <div :style="{ marginBottom: '20px' }">
        <label
          >Throttled Range (Readonly):<input
            type="range"
            min="0"
            max="100"
            :value="throttledValue"
            disabled
            :style="{ width: '100%' }"
          /><span>{{ throttledValue }}</span></label
        >
      </div>
      <throttler.Subscribe
        :selector="
          (state) => ({
            executionCount: state.executionCount,
          })
        "
        v-slot="{ executionCount }"
        ><table>
          <tbody>
            <tr>
              <td>Values Submitted:</td>
              <td>{{ submittedCount }}</td>
            </tr>
            <tr>
              <td>Throttled Execution Count:</td>
              <td>{{ executionCount }}</td>
            </tr>
            <tr>
              <td>Saved Executions:</td>
              <td>
                {{ submittedCount - executionCount }} ({{
                  submittedCount > 0
                    ? (
                        ((submittedCount - executionCount) / submittedCount) *
                        100
                      ).toFixed(2)
                    : 0
                }}% Reduction in execution calls)
              </td>
            </tr>
          </tbody>
        </table>
        <div :style="{ color: '#666', fontSize: '0.9em' }">
          <p>Throttled to 1 update per 250ms</p>
        </div></throttler.Subscribe
      >
      <pre
        :style="{ marginTop: '20px' }"
      ><throttler.Subscribe :selector="(state) => state" v-slot="state">{{ JSON.stringify(state, null, 2) }}</throttler.Subscribe></pre>
    </div>
  </div>
  <TanStackDevtools v-if="dev" :plugins="plugins" />
</template>

Docs
CodeRabbit
Cloudflare
Railway
Clerk
SerpAPI
WorkOS
AG Grid
Netlify
OpenRouter
Sentry
Unkey
Electric
Prisma
CodeRabbit
Cloudflare
Railway
Clerk
SerpAPI
WorkOS
AG Grid
Netlify
OpenRouter
Sentry
Unkey
Electric
Prisma
Debouncer API Reference
Throttler API Reference
Rate Limiter API Reference
Queue API Reference
Batcher API Reference

React Example: UseThrottledValue

import { useState } from 'react'
import ReactDOM from 'react-dom/client'
import { useThrottledValue } from '@tanstack/react-pacer/throttler'

function App1() {
  const [instantCount, setInstantCount] = useState(0)

  function increment() {
    setInstantCount((c) => c + 1)
  }

  // highest-level hook that watches an instant local state value and returns a throttled value
  // optionally, grab the throttler from the last index of the returned array
  const [throttledCount] = useThrottledValue(
    instantCount,
    {
      wait: 1000,
      // enabled: () => instantCount > 2, // optional, defaults to true
    },
    // Alternative to throttler.Subscribe: pass a selector as 3rd arg to cause re-renders and subscribe to state
    // (state) => state,
  )

  return (
    <div>
      <h1>TanStack Pacer useThrottledValue Example 1</h1>
      <table>
        <tbody>
          <tr>
            <td>Instant Count:</td>
            <td>{instantCount}</td>
          </tr>
          <tr>
            <td>Throttled Count:</td>
            <td>{throttledCount}</td>
          </tr>
        </tbody>
      </table>
      <div>
        <button onClick={increment}>Increment</button>
      </div>
    </div>
  )
}

function App2() {
  const [instantSearch, setInstantSearch] = useState('')

  // highest-level hook that watches an instant local state value and returns a throttled value
  const [throttledSearch] = useThrottledValue(
    instantSearch,
    {
      wait: 1000,
      // enabled: instantSearch.length > 2, // optional, defaults to true
    },
    // Alternative to throttler.Subscribe: pass a selector as 3rd arg to cause re-renders and subscribe to state
    // (state) => state,
  )

  function handleSearchChange(e: React.ChangeEvent<HTMLInputElement>) {
    setInstantSearch(e.target.value)
  }

  return (
    <div>
      <h1>TanStack Pacer useThrottledValue Example 2</h1>
      <div>
        <input
          autoFocus
          type="search"
          value={instantSearch}
          onChange={handleSearchChange}
          placeholder="Type to search..."
          style={{ width: '100%' }}
        />
      </div>
      <table>
        <tbody>
          <tr>
            <td>Instant Search:</td>
            <td>{instantSearch}</td>
          </tr>
          <tr>
            <td>Throttled Search:</td>
            <td>{throttledSearch}</td>
          </tr>
        </tbody>
      </table>
    </div>
  )
}

function App3() {
  const [instantExecutionCount, setInstantExecutionCount] = useState(0)
  const [currentValue, setCurrentValue] = useState(50)

  // highest-level hook that watches an instant local state value and returns a throttled value
  const [throttledValue, throttler] = useThrottledValue(
    currentValue,
    {
      wait: 250,
    },
    // Alternative to throttler.Subscribe: pass a selector as 3rd arg to cause re-renders and subscribe to state
    // (state) => state,
  )

  function handleRangeChange(e: React.ChangeEvent<HTMLInputElement>) {
    const newValue = parseInt(e.target.value, 10)
    setCurrentValue(newValue)
    setInstantExecutionCount((c) => c + 1)
  }

  return (
    <div>
      <h1>TanStack Pacer useThrottledValue Example 3</h1>
      <div style={{ marginBottom: '20px' }}>
        <label>
          Current Range:
          <input
            type="range"
            min="0"
            max="100"
            value={currentValue}
            onChange={handleRangeChange}
            style={{ width: '100%' }}
          />
          <span>{currentValue}</span>
        </label>
      </div>
      <div style={{ marginBottom: '20px' }}>
        <label>
          Throttled Range (Readonly):
          <input
            type="range"
            min="0"
            max="100"
            value={throttledValue}
            readOnly
            style={{ width: '100%' }}
          />
          <span>{throttledValue}</span>
        </label>
      </div>
      <throttler.Subscribe
        selector={(state) => ({
          executionCount: state.executionCount,
        })}
      >
        {({ executionCount }) => (
          <>
            <table>
              <tbody>
                <tr>
                  <td>Instant Execution Count:</td>
                  <td>{instantExecutionCount}</td>
                </tr>
                <tr>
                  <td>Throttled Execution Count:</td>
                  <td>{executionCount}</td>
                </tr>
                <tr>
                  <td>Saved Executions:</td>
                  <td>
                    {instantExecutionCount - executionCount} (
                    {instantExecutionCount > 0
                      ? (
                          ((instantExecutionCount - executionCount) /
                            instantExecutionCount) *
                          100
                        ).toFixed(2)
                      : 0}
                    % Reduction in execution calls)
                  </td>
                </tr>
              </tbody>
            </table>
            <div style={{ color: '#666', fontSize: '0.9em' }}>
              <p>Throttled to 1 update per 250ms</p>
            </div>
          </>
        )}
      </throttler.Subscribe>
      <pre style={{ marginTop: '20px' }}>
        <throttler.Subscribe selector={(state) => state}>
          {(state) => JSON.stringify(state, null, 2)}
        </throttler.Subscribe>
      </pre>
    </div>
  )
}

const root = ReactDOM.createRoot(document.getElementById('root')!)
root.render(
  <div>
    <App1 />
    <hr />
    <App2 />
    <hr />
    <App3 />
  </div>,
)
import { useState } from 'react'
import ReactDOM from 'react-dom/client'
import { useThrottledValue } from '@tanstack/react-pacer/throttler'

function App1() {
  const [instantCount, setInstantCount] = useState(0)

  function increment() {
    setInstantCount((c) => c + 1)
  }

  // highest-level hook that watches an instant local state value and returns a throttled value
  // optionally, grab the throttler from the last index of the returned array
  const [throttledCount] = useThrottledValue(
    instantCount,
    {
      wait: 1000,
      // enabled: () => instantCount > 2, // optional, defaults to true
    },
    // Alternative to throttler.Subscribe: pass a selector as 3rd arg to cause re-renders and subscribe to state
    // (state) => state,
  )

  return (
    <div>
      <h1>TanStack Pacer useThrottledValue Example 1</h1>
      <table>
        <tbody>
          <tr>
            <td>Instant Count:</td>
            <td>{instantCount}</td>
          </tr>
          <tr>
            <td>Throttled Count:</td>
            <td>{throttledCount}</td>
          </tr>
        </tbody>
      </table>
      <div>
        <button onClick={increment}>Increment</button>
      </div>
    </div>
  )
}

function App2() {
  const [instantSearch, setInstantSearch] = useState('')

  // highest-level hook that watches an instant local state value and returns a throttled value
  const [throttledSearch] = useThrottledValue(
    instantSearch,
    {
      wait: 1000,
      // enabled: instantSearch.length > 2, // optional, defaults to true
    },
    // Alternative to throttler.Subscribe: pass a selector as 3rd arg to cause re-renders and subscribe to state
    // (state) => state,
  )

  function handleSearchChange(e: React.ChangeEvent<HTMLInputElement>) {
    setInstantSearch(e.target.value)
  }

  return (
    <div>
      <h1>TanStack Pacer useThrottledValue Example 2</h1>
      <div>
        <input
          autoFocus
          type="search"
          value={instantSearch}
          onChange={handleSearchChange}
          placeholder="Type to search..."
          style={{ width: '100%' }}
        />
      </div>
      <table>
        <tbody>
          <tr>
            <td>Instant Search:</td>
            <td>{instantSearch}</td>
          </tr>
          <tr>
            <td>Throttled Search:</td>
            <td>{throttledSearch}</td>
          </tr>
        </tbody>
      </table>
    </div>
  )
}

function App3() {
  const [instantExecutionCount, setInstantExecutionCount] = useState(0)
  const [currentValue, setCurrentValue] = useState(50)

  // highest-level hook that watches an instant local state value and returns a throttled value
  const [throttledValue, throttler] = useThrottledValue(
    currentValue,
    {
      wait: 250,
    },
    // Alternative to throttler.Subscribe: pass a selector as 3rd arg to cause re-renders and subscribe to state
    // (state) => state,
  )

  function handleRangeChange(e: React.ChangeEvent<HTMLInputElement>) {
    const newValue = parseInt(e.target.value, 10)
    setCurrentValue(newValue)
    setInstantExecutionCount((c) => c + 1)
  }

  return (
    <div>
      <h1>TanStack Pacer useThrottledValue Example 3</h1>
      <div style={{ marginBottom: '20px' }}>
        <label>
          Current Range:
          <input
            type="range"
            min="0"
            max="100"
            value={currentValue}
            onChange={handleRangeChange}
            style={{ width: '100%' }}
          />
          <span>{currentValue}</span>
        </label>
      </div>
      <div style={{ marginBottom: '20px' }}>
        <label>
          Throttled Range (Readonly):
          <input
            type="range"
            min="0"
            max="100"
            value={throttledValue}
            readOnly
            style={{ width: '100%' }}
          />
          <span>{throttledValue}</span>
        </label>
      </div>
      <throttler.Subscribe
        selector={(state) => ({
          executionCount: state.executionCount,
        })}
      >
        {({ executionCount }) => (
          <>
            <table>
              <tbody>
                <tr>
                  <td>Instant Execution Count:</td>
                  <td>{instantExecutionCount}</td>
                </tr>
                <tr>
                  <td>Throttled Execution Count:</td>
                  <td>{executionCount}</td>
                </tr>
                <tr>
                  <td>Saved Executions:</td>
                  <td>
                    {instantExecutionCount - executionCount} (
                    {instantExecutionCount > 0
                      ? (
                          ((instantExecutionCount - executionCount) /
                            instantExecutionCount) *
                          100
                        ).toFixed(2)
                      : 0}
                    % Reduction in execution calls)
                  </td>
                </tr>
              </tbody>
            </table>
            <div style={{ color: '#666', fontSize: '0.9em' }}>
              <p>Throttled to 1 update per 250ms</p>
            </div>
          </>
        )}
      </throttler.Subscribe>
      <pre style={{ marginTop: '20px' }}>
        <throttler.Subscribe selector={(state) => state}>
          {(state) => JSON.stringify(state, null, 2)}
        </throttler.Subscribe>
      </pre>
    </div>
  )
}

const root = ReactDOM.createRoot(document.getElementById('root')!)
root.render(
  <div>
    <App1 />
    <hr />
    <App2 />
    <hr />
    <App3 />
  </div>,
)